/*
 * standard menu Device Description
 *
 * @(#)menu.ddl	9.1 6/14/93
 */

//XXXX#include "bi_codes.h"
//XXXX#include "macros.ddl"

//XXXXMANUFACTURER STANDARD, DEVICE_TYPE _MENU, DEVICE_REVISION 1, DD_REVISION 1

/*
 *	  Menus
 */
#ifdef XXXX
MENU root_menu
{
	LABEL [bus_devices];
	ITEMS
	{
		device_setup,					 				/* menu */
		/* This is our suggested display for single variable
		   devices. If you have a multiparameter device you
		   may want to put other variables here. */
		PV.DIGITAL_VALUE (DISPLAY_VALUE),	   			/* variable */
		/* Some prefer to change the following entry to the variable
			attached to PV.ANALOG_VALUE (e.g. analog_output_value)
			to avoid the display of PV before AO */
		PV.ANALOG_VALUE (DISPLAY_VALUE, READ_ONLY),		/* variable */
		PV.LOWER_RANGE_VALUE (DISPLAY_VALUE),			/* variable */
		PV.UPPER_RANGE_VALUE (DISPLAY_VALUE)			/* variable */
	}
}

MENU device_setup
{
		LABEL [device_setup];
		ITEMS
		{
		process_variables,				/* menu */
		diag_service,					/* menu */
		basic_setup,					/* menu */
		detailed_setup,					/* menu */
		review (REVIEW)					/* menu */
		}
}
#endif //XXXX

MENU process_variables
{
	LABEL [process_variables];
	ITEMS
	{
#ifdef YOU_FILL_THIS_IN_WITH_YOUR_STUFF
		/* Multiparameter instruments may wish to use directories
		to group their variables. This example is for a single
		parameter instrument.

		DO NOT USE PV REFERENCES HERE. INSTEAD USE COLLECTION
		REFERENCES. What we want to display are the transmitter
		variables, not which is attached to PV */

		process_pressure.DIGITAL_VALUE (DISPLAY_VALUE),	/* variable */
		process_pressure.PERCENT_RANGE (DISPLAY_VALUE),	/* variable */
		analog_output_value (DISPLAY_VALUE, READ_ONLY)	/* variable */
#else
		dummy_menu_entry
#endif
		/* Your extra variables here. */
	}
}

MENU diag_service
{
	LABEL [diagnostics_and_service];
	ITEMS
	{
		test_device,	/* menu */
		loop_test,		/* common-method */
		calibration,
		dac_trim		/* common-method  (OPTIONAL) */
	}
}

MENU test_device
{
		LABEL [test_device];
		ITEMS
		{
			status_display,
#ifdef YOU_FILL_THIS_IN_WITH_YOUR_STUFF
			/* Put whatever you selftest method is here */
			self_test
#else
		dummy_menu_entry
#endif
		}
}

MENU calibration
{
		LABEL [calibration];
		ITEMS
		{
#ifdef YOU_FILL_THIS_IN_WITH_YOUR_STUFF
			/* This is really rerange but we call it
			   calibration because of common venacular. */
			applied_rerange,		/* Method */
			key_pad_rerange 		/* Edit display */
#else
		dummy_menu_entry
#endif
		}
}

#ifdef XXXX
MENU status_display
{
		LABEL [status];
		ITEMS
		{
#ifdef YOU_FILL_THIS_IN_WITH_YOUR_STUFF
			/* Put your status bytes returned in command 48 here */
			xmtr_specific_status_0 (DISPLAY_VALUE),		/* var */
			xmtr_specific_status_1 (DISPLAY_VALUE)		/* var */
#else
		dummy_menu_entry
#endif
		}
}
#else
MENU status_display
{
		LABEL [menu_diagnosis];
		ITEMS
		{
			/* Put your status bytes returned in command 48 here */
			xmtr_specific_status_0 (DISPLAY_VALUE),		/* var */
			xmtr_specific_status_1 (DISPLAY_VALUE)		/* var */
		}
}
#endif

MENU Tab_basic_setup
  {
		LABEL "basic_setup" "|de|Grundeinstellungen";
		ITEMS
		{
	//			tag,							/* variable */
	//			PV.DIGITAL_UNITS,				/* variable */
	//			rerange,						/* variable */
	//			device_info,					/* menu */
	//			PV.TRANSFER_FUNCTION, 			/* OPTIONAL */
		conf_disp_language,
		conf_disp_initial
		PV.DAMPING_VALUE 				/* OPTIONAL */
		}
  }

MENU Tab_ident
  {
  LABEL	[menu_ident];
  ITEMS
    {
    manufacturer_id,
    device_type,
    Tab_ident_device
    }
  }

MENU Tab_ident_device
{
	LABEL	"device information" "|de|Gerteinformationen";
	ITEMS
	{
		device_type,
		device_id,

		universal_revision,
		transmitter_revision,
		software_revision,
		write_protect,
		tag,
		descriptor,
		date,
		message,
		final_assembly_number
	}
}


MENU Tab_inputs
  {
  LABEL "Inputs" "|de|Eingnge";
  ITEMS
    {
    Tab_volume_flow,
    Tab_binary_input
    }
  }

MENU Tab_volume_flow
  {
  LABEL    "Flow" "|de|Durchflu";
  ITEMS
    {
    volume_flow_units,
sensor_upper_limit (DISPLAY_VALUE),
sensor_lower_limit (DISPLAY_VALUE),
    upper_range_value,
    lower_range_value (READ_ONLY),
    flow_limit_min,
    flow_limit_max,
    flow_limit_hyst,
    low_flow_cutoff,
    low_flow_cutoff_hyst,
dichte
    }
  }






#ifdef XXXX
MENU detailed_setup
{
	LABEL [detailed_setup];
	ITEMS
	{
		measuring_elements,				/* menu */
		signal_conditioning,			/* menu */
		output_conditioning,			/* menu */
		device_info						/* menu */
#ifdef YOU_FILL_THIS_IN_WITH_YOUR_STUFF
		/* If you have a totalizer, etc put it here */
		computations
#endif
	}
}
#endif //XXXX
MENU detailed_setup
{//wird nicht benutzt
	LABEL [detailed_setup];
	ITEMS
	{
		measuring_elements,
		mnu_aufnehmer,
		/* Verweis: mnu_totalizers: bei process variables */
		mnu_local_display,
//		mnu_SV_map,
		mnu_pulse,
		mnu_current_outputs,
		mnu_binary_outputs,
		mnu_selftest,
		//hart_output	//PDM-Dialoge vorhanden
	}
}
//end redefinition






MENU analog_output
{
		LABEL [analog_output];
		ITEMS
		{
#ifdef YOU_FILL_THIS_IN_WITH_YOUR_STUFF
			analog_output_value (DISPLAY_VALUE,READ_ONLY),	/* variable */
			analog_output_alarm_select (DISPLAY_VALUE),
			loop_test,									  	/* method */
			dac_trim									   	/* method */
#else
		dummy_menu_entry
#endif
		}
}

MENU hart_output
{
		LABEL [HART_output];
		ITEMS
		{
#ifdef XXXX
			polling_address (DISPLAY_VALUE),		/* Variable	*/
			request_preambles (DISPLAY_VALUE),		/* Variable	*/
			burst_mode_select (DISPLAY_VALUE),		/* variable */
			burst_command_number (DISPLAY_VALUE)	/* variable */
#else	//Redefinition
			polling_address (DISPLAY_VALUE),		/* Variable	*/
			request_preambles (DISPLAY_VALUE),	/* Variable	*/
			response_preambles (DISPLAY_VALUE)	/* variable */
#endif
		}
}

#ifdef XXXX
MENU frequency_output
{
		LABEL [frequency_output];
		ITEMS
		{
			dummy_menu_entry
		}
}

MENU discrete_output
{
		LABEL [discrete_output];
		ITEMS
		{
			dummy_menu_entry
		}
}

MENU review
{
	LABEL [review];
	ITEMS
	{
	/* List all variable accessable to the user in this menu */
#ifdef YOU_FILL_THIS_IN_WITH_YOUR_STUFF
		device_type (DISPLAY_VALUE, READ_ONLY),             /* var */
		private_label_distributor (DISPLAY_VALUE, READ_ONLY), /* var */
		meter_installation (DISPLAY_VALUE, READ_ONLY),		/* var */
		write_protect (DISPLAY_VALUE, READ_ONLY),			/* var */
		manufacturer_id (DISPLAY_VALUE, READ_ONLY),			/* var */
		device_id (DISPLAY_VALUE, READ_ONLY),				/* var */
		tag (DISPLAY_VALUE, READ_ONLY), 					/* var */
		descriptor (DISPLAY_VALUE, READ_ONLY),				/* var */
		message (DISPLAY_VALUE, READ_ONLY),					/* var */
		date (DISPLAY_VALUE, READ_ONLY),					/* var */
		final_assembly_number (DISPLAY_VALUE),				/* var */
		universal_revision (DISPLAY_VALUE, READ_ONLY),		/* var */
		transmitter_revision (DISPLAY_VALUE, READ_ONLY),	/* var */
		software_revision (DISPLAY_VALUE, READ_ONLY),		/* var */
		burst_mode_select (DISPLAY_VALUE, READ_ONLY),		/* var */
		burst_command_number (DISPLAY_VALUE, READ_ONLY),	/* var */
		polling_address (DISPLAY_VALUE, READ_ONLY),			/* var */
		request_preambles (DISPLAY_VALUE, READ_ONLY)		/* var */
#else
		dummy_menu_entry
#endif
	}
}
#endif //XXXX

#ifdef XXXX
MENU hot_key
{
	LABEL [hot_key];
	ITEMS
	{
		rerange 				/* edit_display */
	}
}
#endif

#ifdef XXXX
WRITE_AS_ONE range_wao
{
	PV.LOWER_RANGE_VALUE,		/* variable */
	PV.UPPER_RANGE_VALUE		/* variable */
}

EDIT_DISPLAY rerange
{
  LABEL [range_values];

  EDIT_ITEMS { range_wao, PV.DIGITAL_UNITS }

  DISPLAY_ITEMS {
				PV.LOWER_SENSOR_LIMIT,
				PV.UPPER_SENSOR_LIMIT
				}
}
#endif

/* Simply a place holder so I can compile */
VARIABLE dummy_menu_entry
   {
   LABEL [not_applicable];
   HANDLING READ;
   TYPE ENUMERATED
      {
         {0, [not_applicable] }
      }
}

//???		sensor_serial_number(DISPLAY_VALUE),
//sensor_range_menu auch umc2